// Exercice 5 - Correction J.M.B.

#include <stdio.h>
#include <math.h>	// Voir note en bas de page

int main(int argc, char *argv[])
{
	int a, b, c , delta;
	float x, x1, x2;

	printf("=== Racines réelle de a.x^2 + b.x + c ===\n");
	printf("Entrez l'entier a : ");
	scanf("%d", &a);
	printf("Entrez l'entier b : ");
	scanf("%d", &b);
	printf("Entrez l'entier c : ");
	scanf("%d", &c);
	printf("\n");

	if (a == 0)
	{
		if (b == 0)
		{
			printf("Le polynôme n'a pas de racine\n");
		}
		else
		{
			x = -1.0*c/b;

			printf("Le polynôme a une racine réelle :\n");
			printf("x = %f\n", x);
		}
	}
	else
	{
		delta = pow(b,2)-4*a*c; // b*b = pow(b,2) (fonction puissance "power")
		printf("Le déterminant 'delta' vaut : %d\n", delta);

		if (delta < 0)
		{
			printf("Le polynôme n'a pas de racines réelles");
		}
		else if (delta > 0)
		{
			x1 = (- b + sqrt(delta))/(2*a);
			x2 = (- b - sqrt(delta))/(2*a);

			printf("Le polynôme a deux racines réelles :\n");
			printf("x1 = %f et x2 = %f\n", x1, x2);
		}
		else
		{
			x = -1.0*b/(2*a);

			printf("Le polynôme a une racine réelle double :\n");
			printf("x = %f\n", x);
		}
	}

	return 0;
}

/* IMPORTANT : A la compilation on ajoute "-lm" pour inclure la librairie "math.h" au programme :
gcc -c ex5.c -o ex5.o
gcc ex5.o -lm -o ex5

"-lm" veut dire "lier le fichier libm" ("l" pour "lier" et "m" pour "libm", librairie de math de gcc)
au programme. Ce lien est soit statique, c-a-d que l'éxécutable "ex5" contiendra tout le code binaire
nécessaire à l'éxecution de la fonction sqrt(), soit dynamique, c-a-d que l'exécutable "ex5" saura juste à
quel autre éxécutable sous-traiter la même fonction sqrt(). Sous Linux les librairies statiques portent
l'extension .a (archive Unix traditionnelle) et les librairies dynamiques .so (shared object). Sous Windows
ce sont respectivement des .lib (library) et des .dll (dynamic link library).
*/
