// Feuille5 - Ex2 - Correction J.M.B.

#include <stdio.h>
#include <stdlib.h>
#include <math.h> // fonction puissance pow() (cf. variance() plus bas)

int lectureEntier(int min, int max);
void lectureSuite(int tab[], int n);
void afficherSuite(int tab[], int n);
float moyenne(int tab[], int n);
int minimum(int tab[], int n);
int indMinPair(int tab[], int n);
float variance(int tab[], int n, float moy);
int nbPositifsIndCons(int tab[], int n);

int main(void)
{
    // 1. Entier entre 1 et 20
    printf("\n1/ Entrer un entier 'a' entre 1 et 20 : ");
    int a = lectureEntier(1, 20);
    
    printf("a = %d\n", a);

    // 2. Entrée d'une suite d'entiers
    int n = 9, tableau[n];
    lectureSuite(tableau, n);
    afficherSuite(tableau, n); // affichage du tableau
    
    // 3. Moyenne du tableau
    printf("Moyenne du tableau = %f\n", moyenne(tableau,n));
    
    // 4. Valeur minimum
    printf("Valeur minimum du tableau = %d\n", minimum(tableau,n));
    
    // 5. Premier indice pair (-1 sinon)
    printf("Position du premier entier pair = %d\n", indMinPair(tableau,n));
    
    // 6. Variance du tableau
    printf("Variance du tableau = %f\n", variance(tableau,n, moyenne(tableau,n)));
    
    // 7. Maximum de valeurs strictement positives consécutives
    printf("Nombre maximum de valeurs strictement positives consécutives = %d\n\n", nbPositifsIndCons(tableau,n));

    return 0;
}

int lectureEntier(int min, int max)
{
    int n;
    scanf("%d", &n);
    
    if ((n < min) || (n > max))
    {
        n = lectureEntier(min, max);
    }
    
    return n;
}

void lectureSuite(int tab[], int n)
{
    int i;
    
    printf("\nEntrer une suite de %d entiers :\n", n);
    for (i = 0; i < n ; i++)
    {
    	printf("valeur n°%d : ", i+1);
        scanf("%d", &tab[i]);
    }
}

void afficherSuite(int tab[], int n)
{
    int i;
    
    printf("\nTableau = [");
    for (i = 0; i < n-1 ; i++)
    {
        printf("%d, ", tab[i]);
    }
    printf("%d]\n", tab[n-1]);
}

float moyenne(int tab[], int n)
{
    int i, somme = 0;
    
    for (i = 0; i < n ; i++)
    {
    	somme = somme + tab[i];
    }
    
    return (float)somme/n;
}

int minimum(int tab[], int n)
{
    int i, min = tab[0];
    
    for (i = 1; i < n ; i++)
    {
    	if (tab[i] < min)
    	{
    	    min = tab[i];
    	}
    }
    
    return min;
}

int indMinPair(int tab[], int n)
{
    int i=0, indPair = -1; // a priori l'indice est impair
     
    while ((i < n) && (indPair == -1))
    {
    	if (tab[i]%2 == 0)
    	{
    	    indPair = i;
    	}
    	i++;
    }
    
    return indPair + 1; // "+1" car indice [0, n - 1] -> position [1, n]
}

float variance(int tab[], int n, float moy)
{
    int i;
    float somme = 0;
    
    for (i = 0; i < n ; i++)
    {
    	somme = somme + pow(1.0*tab[i] - moy, 2); // fonction pow() définie dans math.h
    }
    
    return somme/n; //Var de n ici et non Var n-1 ! (cf. statistiques sur les estimateurs non biaisés...
}

int nbPositifsIndCons(int tab[], int n)
{
    int i, compt = 0, maxCompt = 0;
    
    for (i = 0; i < n ; i++)
    {
    	if (tab[i] > 0)
    	{
    	    compt++;
    	    //printf("%d -> %d\n", tab[i], compt);
    	}
    	else
    	{
    	    if (compt > maxCompt)
    	        maxCompt = compt;
    	    compt = 0;
    	    //printf("%d -> %d\n", tab[i], compt);
    	}
    }
    
    if (compt > maxCompt)
    	maxCompt = compt;
    
    return maxCompt;
}

