// Feuille5 - Ex6 - Correction J.M.B.

#include <stdio.h>
#include <stdlib.h> // contient math.h pour utiliser abs()

int lectureEntier(int max);
int ladyCanMove(int l, int c, int x, int y);
void casesAccess1(int l, int c, int dam[8][8]);
void casesAccess2(int l, int c, int dam[], int n);
void dispGrid1(int dam[8][8]);
void dispGrid2(int dam[], int n);

int main(void)
{
	int l, c, n = 8;
	
	printf("\nEntrer la ligne où se trouve la dame :\n");
	l = lectureEntier(n);
	printf("Entrer la colonne où se trouve la dame :\n");
	c = lectureEntier(n);
	
	printf("\nVersion n°1 :");
	int damier1[8][8];		// tableau double entrée
	casesAccess1(l, c, damier1);
	dispGrid1(damier1);
	
	printf("\nVersion n°2 :");
	int damier2[64];		// tableau simple entrée (exécution beaucoup plus rapide !)
	casesAccess2(l, c, damier2, n);
	dispGrid2(damier2, n);
	
	return 0;
}

int lectureEntier(int max)
{
	int n;
	
	printf("-> entier entre 1 et 8 : ");
	scanf("%d", &n);
	
	while((n < 1) || (n > max))
	{
		n = lectureEntier(max);
	}
	
	return n;
}

int ladyCanMove(int x, int y, int l, int c)
{
	if ((x == l) || (y == c) || (abs(y-c) == abs(x-l)))
		return 1;
	else
		return 0;
}

void casesAccess1(int l, int c, int dam[8][8])
{
	int i, j;
	
	for(i = 0; i < 8; i++)
	{
		for(j = 0; j < 8; j++)
		{
			if(ladyCanMove(l-1,c-1,i,j))
			{
				dam[i][j] = 1;
			}
			else
			{
				dam[i][j] = 0;
			}
		}
	}
	dam[l-1][c-1] = 2;
}

void casesAccess2(int l, int c, int dam[], int n)
{
	int k, i, j;
	
	for(k = 0; k < n*n; k++)
	{
		i = k/n; j = k%n;
		
		if ((i == l-1) && (j == c-1))
		{
			dam[k] = 2;
		}
		else
		{
			if(ladyCanMove(l-1,c-1,i,j))
			{
				dam[k] = 1;
			}
			else
			{
				dam[k] = 0;
			}
		}
	}
}

void dispGrid1(int dam[8][8])
{
	int i,j;
	printf("\n");
	
	for(i = 0; i < 9; i++)
	{
		printf("+");
	}
	printf("+\n+");
	
	for(i = 0; i < 8; i++)
	{
		for(j = 0; j < 8; j++)
		{
			if (dam[i][j] == 2)
				printf("D");
			else if (dam[i][j] == 1)
				printf("*");
			else
				printf("-");
		}
		printf("+\n+");
	}
	
	for(i = 0; i < 9; i++)
	{
		printf("+");
	}
	printf("\n");
}

void dispGrid2(int dam[], int n)
{
	int k;
	printf("\n");
	
	for(k = 0; k < n+1; k++)
	{
		printf("+");
	}
	printf("+\n+");
	
	for(k = 0; k < n*n; k++)
	{
		if (dam[k] == 2)
			printf("D");
		else if (dam[k] == 1)
			printf("*");
		else
			printf("-");
		
		if (k%n == n-1)
			printf("+\n+");
	}
	
	for(k = 0; k < n+1; k++)
	{
		printf("+");
	}
	printf("\n\n");
}
